Whamcloud - gitweb
LU-3664 test: get_param atime_diff returns multiple values
[fs/lustre-release.git] / lustre / tests / sanityn.sh
index df7e017..1170b2d 100644 (file)
@@ -3,17 +3,14 @@
 set -e
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test: 3192 15528/3811 16929 9977 15528/11549 18080
-ALWAYS_EXCEPT="                14b  19         22    28   29          35    $SANITYN_EXCEPT"
+# bug number for skipped test: 3192 LU-1205 15528/3811 16929 9977 15528/11549 18080
+ALWAYS_EXCEPT="                14b  18c     19         22    28   29          35    $SANITYN_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 # bug number for skipped test:        12652 12652
 grep -q 'Enterprise Server 10' /etc/SuSE-release 2> /dev/null &&
        ALWAYS_EXCEPT="$ALWAYS_EXCEPT 11    14" || true
 
-# Tests that fail on uml
-[ "$UML" = "true" ] && EXCEPT="$EXCEPT 7"
-
 # It will be ported soon.
 EXCEPT="$EXCEPT 22"
 
@@ -22,11 +19,10 @@ PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
 
 SIZE=${SIZE:-40960}
 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
-GETSTRIPE=${GETSTRIPE:-lfs getstripe}
-SETSTRIPE=${SETSTRIPE:-lstripe}
 MCREATE=${MCREATE:-mcreate}
 OPENFILE=${OPENFILE:-openfile}
 OPENUNLINK=${OPENUNLINK:-openunlink}
+export MULTIOP=${MULTIOP:-multiop}
 export TMP=${TMP:-/tmp}
 MOUNT_2=${MOUNT_2:-"yes"}
 CHECK_GRANT=${CHECK_GRANT:-"yes"}
@@ -44,7 +40,11 @@ init_test_env $@
 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 init_logging
 
-[ "$SLOW" = "no" ] && EXCEPT_SLOW="12 23 33a"
+[ $(facet_fstype $SINGLEMDS) = "zfs" ] &&
+# bug number for skipped test:        LU-2840 LU-2189 LU-2776
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 21      36      51a"
+
+[ "$SLOW" = "no" ] && EXCEPT_SLOW="33a"
 
 FAIL_ON_ERROR=false
 
@@ -53,11 +53,11 @@ TRACE=${TRACE:-""}
 
 check_and_setup_lustre
 
-LOVNAME=`lctl get_param -n llite.*.lov.common_name | tail -n 1`
-OSTCOUNT=`lctl get_param -n lov.$LOVNAME.numobd`
+LOVNAME=$($LCTL get_param -n llite.*.lov.common_name | tail -n 1)
+OSTCOUNT=$($LCTL get_param -n lov.$LOVNAME.numobd)
 
 assert_DIR
-rm -rf $DIR1/[df][0-9]* $DIR1/lnk
+rm -rf $DIR1/[df][0-9]* $DIR1/lnk $DIR/[df].${TESTSUITE}*
 
 SAMPLE_FILE=$TMP/$(basename $0 .sh).junk
 dd if=/dev/urandom of=$SAMPLE_FILE bs=1M count=1
@@ -134,6 +134,41 @@ test_2e() {
 }
 run_test 2e "check chmod on root is propagated to others"
 
+test_2f() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local MDTIDX=1
+       local remote_dir=$tdir/remote_dir
+
+       mkdir -p $DIR1/$tdir
+       $LFS mkdir -i $MDTIDX $DIR1/$remote_dir ||
+                  error "Create remote directory failed"
+
+       touch $DIR1/$remote_dir/$tfile ||
+               error "Create file under remote directory failed"
+       chmod 777 $DIR1/$remote_dir/$tfile ||
+               error "Chmod file under remote directory failed"
+
+       $CHECKSTAT -t file -p 0777 $DIR2/$remote_dir/$tfile ||
+               error "Check attr of file under remote directory failed"
+
+       chown $RUNAS_ID:$RUNAS_GID $DIR1/$remote_dir/$tfile ||
+               error "Chown file under remote directory failed"
+
+       $CHECKSTAT -u \#$RUNAS_ID -g \#$RUNAS_GID $DIR2/$remote_dir/$tfile ||
+               error "Check owner of file under remote directory failed"
+
+       cd $DIR2/$remote_dir || error "enter remote dir"
+       rm -rf $DIR1/$remote_dir/$tfile ||
+               error "Unlink remote directory failed"
+
+       $CHECKSTAT -t file $DIR2/$remote_dir/$tfile &&
+               error "unlink file still exists!"
+
+        cd $DIR2/$tdir || error "exit remote dir"
+       rm -rf $DIR1/$tdir || error "unlink directory failed"
+}
+run_test 2f "check attr/owner updates on DNE with 2 mtpt's"
+
 test_3() {
        local target="this/is/good"
        ln -s $target $DIR1/$tfile || error "ln -s $target $DIR1/$tfile failed"
@@ -222,7 +257,7 @@ test_10b() {
 run_test 10b "write of file with sub-page size on multiple mounts "
 
 test_11() {
-       mkdir $DIR1/d11
+       test_mkdir $DIR1/d11
        multiop_bg_pause $DIR1/d11/f O_c || return 1
        MULTIPID=$!
        cp -p /bin/ls $DIR1/d11/f
@@ -240,7 +275,7 @@ test_12() {
 run_test 12 "test lock ordering (link, stat, unlink) ==========="
 
 test_13() {    # bug 2451 - directory coherency
-       mkdir $DIR1/d13 || error
+       test_mkdir $DIR1/d13 || error
        cd $DIR1/d13 || error
        ls
        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
@@ -256,7 +291,7 @@ test_13() { # bug 2451 - directory coherency
 run_test 13 "test directory page revocation ===================="
 
 test_14() {
-       mkdir -p $DIR1/$tdir
+       test_mkdir -p $DIR1/$tdir
        cp -p /bin/ls $DIR1/$tdir/$tfile
        multiop_bg_pause $DIR1/$tdir/$tfile Ow_c || return 1
        MULTIPID=$!
@@ -268,11 +303,11 @@ test_14() {
 run_test 14 "execution of file open for write returns -ETXTBSY ="
 
 test_14a() {
-        mkdir -p $DIR1/d14
+       test_mkdir -p $DIR1/d14
        cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
         MULTIOP_PID=$!
-        multiop $DIR2/d14/multiop Oc && error "expected error, got success"
+        $MULTIOP $DIR2/d14/multiop Oc && error "expected error, got success"
         kill -USR1 $MULTIOP_PID || return 2
         wait $MULTIOP_PID || return 3
         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
@@ -280,7 +315,7 @@ test_14a() {
 run_test 14a "open(RDWR) of executing file returns -ETXTBSY ===="
 
 test_14b() { # bug 3192, 7040
-        mkdir -p $DIR1/d14
+       test_mkdir -p $DIR1/d14
        cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
         MULTIOP_PID=$!
@@ -294,7 +329,7 @@ test_14b() { # bug 3192, 7040
 run_test 14b "truncate of executing file returns -ETXTBSY ======"
 
 test_14c() { # bug 3430, 7040
-       mkdir -p $DIR1/d14
+       test_mkdir -p $DIR1/d14
        cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
        MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
         MULTIOP_PID=$!
@@ -307,7 +342,7 @@ test_14c() { # bug 3430, 7040
 run_test 14c "open(O_TRUNC) of executing file return -ETXTBSY =="
 
 test_14d() { # bug 10921
-       mkdir -p $DIR1/d14
+       test_mkdir -p $DIR1/d14
        cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
        MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
         MULTIOP_PID=$!
@@ -323,17 +358,41 @@ run_test 14d "chmod of executing file is still possible ========"
 test_15() {    # bug 974 - ENOSPC
        echo "PATH=$PATH"
        sh oos2.sh $MOUNT1 $MOUNT2
+       wait_delete_completed
        grant_error=`dmesg | grep "> available"`
        [ -z "$grant_error" ] || error "$grant_error"
 }
 run_test 15 "test out-of-space with multiple writers ==========="
 
+COUNT=${COUNT:-2500}
+# The FSXNUM reduction for ZFS is needed until ORI-487 is fixed.
+# We don't want to skip it entirely, but ZFS is VERY slow and cannot
+# pass a 2500 operation dual-mount run within the time limit.
+if [ "$(facet_fstype ost1)" = "zfs" ]; then
+       FSXNUM=$((COUNT / 5))
+       FSXP=1
+elif [ "$SLOW" = "yes" ]; then
+       FSXNUM=$((COUNT * 5))
+       FSXP=500
+else
+       FSXNUM=$COUNT
+       FSXP=100
+fi
+
 test_16() {
-       rm -f $MOUNT1/fsxfile
-       lfs setstripe $MOUNT1/fsxfile -c -1 # b=10919
-       fsx -c 50 -p 100 -N 2500 -l $((SIZE * 256)) -S 0 $MOUNT1/fsxfile $MOUNT2/fsxfile
+       local file1=$DIR1/$tfile
+       local file2=$DIR2/$tfile
+
+       # to allocate grant because it may run out due to test_15.
+       lfs setstripe -c -1 $file1
+       dd if=/dev/zero of=$file1 bs=$STRIPE_BYTES count=$OSTCOUNT oflag=sync
+       dd if=/dev/zero of=$file2 bs=$STRIPE_BYTES count=$OSTCOUNT oflag=sync
+       rm -f $file1
+
+       lfs setstripe -c -1 $file1 # b=10919
+       fsx -c 50 -p $FSXP -N $FSXNUM -l $((SIZE * 256)) -S 0 $file1 $file2
 }
-run_test 16 "2500 iterations of dual-mount fsx ================="
+run_test 16 "$FSXNUM iterations of dual-mount fsx"
 
 test_17() { # bug 3513, 3667
        remote_ost_nodsh && skip "remote OST with nodsh" && return
@@ -351,42 +410,59 @@ test_17() { # bug 3513, 3667
 run_test 17 "resource creation/LVB creation race ==============="
 
 test_18() {
-       $LUSTRE/tests/mmap_sanity -d $MOUNT1 -m $MOUNT2
+        # turn e.g. ALWAYS_EXCEPT="18c" into "-e 3"
+        local idx
+        local excepts=
+        for idx in {a..z}; do
+                local ptr=EXCEPT_ALWAYS_18$idx
+                [ x${!ptr} = xtrue ] || continue
+
+                excepts="$excepts -e $(($(printf %d \'$idx)-96))"
+        done
+
+       $LUSTRE/tests/mmap_sanity -d $MOUNT1 -m $MOUNT2 $excepts
        sync; sleep 1; sync
 }
 run_test 18 "mmap sanity check ================================="
 
 test_19() { # bug3811
-       [ -d /proc/fs/lustre/obdfilter ] || return 0
+       local node=$(facet_active_host ost1)
+
+       # check whether obdfilter is cache capable at all
+       if ! get_osd_param $node '' read_cache_enable >/dev/null; then
+               echo "not cache-capable obdfilter"
+               return 0
+       fi
 
-       MAX=`lctl get_param -n obdfilter.*.readcache_max_filesize | head -n 1`
-       lctl set_param -n obdfilter.*OST*.readcache_max_filesize=4096
-       dd if=/dev/urandom of=$TMP/f19b bs=512k count=32
-       SUM=`cksum $TMP/f19b | cut -d" " -f 1,2`
-       cp $TMP/f19b $DIR1/f19b
+       local MAX=$(get_osd_param $node '' readcache_max_filesize | \
+                   head -n 1)
+       set_osd_param $node '' readcache_max_filesize 4096
+       dd if=/dev/urandom of=$TMP/$tfile bs=512k count=32
+       local SUM=$(cksum $TMP/$tfile | cut -d" " -f 1,2)
+       cp $TMP/$tfile $DIR1/$tfile
        for i in `seq 1 20`; do
-               [ $((i % 5)) -eq 0 ] && log "test_18 loop $i"
+               [ $((i % 5)) -eq 0 ] && log "$testname loop $i"
                cancel_lru_locks osc > /dev/null
-               cksum $DIR1/f19b | cut -d" " -f 1,2 > $TMP/sum1 & \
-               cksum $DIR2/f19b | cut -d" " -f 1,2 > $TMP/sum2
+               cksum $DIR1/$tfile | cut -d" " -f 1,2 > $TMP/sum1 & \
+               cksum $DIR2/$tfile | cut -d" " -f 1,2 > $TMP/sum2
                wait
-               [ "`cat $TMP/sum1`" = "$SUM" ] || \
-                       error "$DIR1/f19b `cat $TMP/sum1` != $SUM"
-               [ "`cat $TMP/sum2`" = "$SUM" ] || \
-                       error "$DIR2/f19b `cat $TMP/sum2` != $SUM"
+               [ "$(cat $TMP/sum1)" = "$SUM" ] || \
+                       error "$DIR1/$tfile $(cat $TMP/sum1) != $SUM"
+               [ "$(cat $TMP/sum2)" = "$SUM" ] || \
+                       error "$DIR2/$tfile $(cat $TMP/sum2) != $SUM"
        done
-       lctl set_param -n obdfilter.*OST*.readcache_max_filesize=$MAX
-       rm $DIR1/f19b
+       set_osd_param $node '' readcache_max_filesize $MAX
+       rm $DIR1/$tfile
 }
 run_test 19 "test concurrent uncached read races ==============="
 
 test_20() {
-       mkdir $DIR1/d20
+       test_mkdir $DIR1/d20
        cancel_lru_locks osc
        CNT=$((`lctl get_param -n llite.*.dump_page_cache | wc -l`))
-       multiop $DIR1/f20 Ow8190c
-       multiop $DIR2/f20 Oz8194w8190c
-       multiop $DIR1/f20 Oz0r8190c
+       $MULTIOP $DIR1/f20 Ow8190c
+       $MULTIOP $DIR2/f20 Oz8194w8190c
+       $MULTIOP $DIR1/f20 Oz0r8190c
        cancel_lru_locks osc
        CNTD=$((`lctl get_param -n llite.*.dump_page_cache | wc -l` - $CNT))
        [ $CNTD -gt 0 ] && \
@@ -396,45 +472,45 @@ run_test 20 "test extra readahead page left in cache ===="
 
 cleanup_21() {
        trap 0
-       umount $DIR1/d21
+       umount $DIR1/$tdir
 }
 
 test_21() { # Bug 5907
-       mkdir $DIR1/d21
-       mount /etc $DIR1/d21 --bind || error "mount failed" # Poor man's mount.
+       test_mkdir $DIR1/$tdir
+       mount /etc $DIR1/$tdir --bind || error "mount failed" # Poor man's mount.
        trap cleanup_21 EXIT
-       rmdir -v $DIR1/d21 && error "Removed mounted directory"
-       rmdir -v $DIR2/d21 && echo "Removed mounted directory from another mountpoint, needs to be fixed"
-       test -d $DIR1/d21 || error "Mounted directory disappeared"
+       rmdir -v $DIR1/$tdir && error "Removed mounted directory"
+       rmdir -v $DIR2/$tdir && echo "Removed mounted directory from another mountpoint, needs to be fixed"
+       test -d $DIR1/$tdir || error "Mounted directory disappeared"
        cleanup_21
-       test -d $DIR2/d21 || test -d $DIR1/d21 && error "Removed dir still visible after umount"
+       test -d $DIR2/$tdir || test -d $DIR1/$tdir && error "Removed dir still visible after umount"
        true
 }
 run_test 21 " Try to remove mountpoint on another dir ===="
 
 test_23() { # Bug 5972
-       echo "others should see updated atime while another read" > $DIR1/f23
-       
+       local at_diff=$(do_facet $SINGLEMDS \
+               $LCTL get_param -n mdd.*MDT0000*.atime_diff | head -1)
+       echo "atime should be updated while another read" > $DIR1/$tfile
+
        # clear the lock(mode: LCK_PW) gotten from creating operation
        cancel_lru_locks osc
-       
-       time1=`date +%s`        
-       #MAX_ATIME_DIFF 60, we update atime only if older than 60 seconds
-       sleep 61
-       
-       multiop_bg_pause $DIR1/f23 or20_c || return 1
+       time1=$(date +%s)
+       echo "now is $time1"
+       sleep $((at_diff + 1))
+
+       echo "starting reads"
+       multiop_bg_pause $DIR1/$tfile or20_c || return 1
         # with SOM and opencache enabled, we need to close a file and cancel
         # open lock to get atime propogated to MDS
-        kill -USR1 $!
+        kill -USR1 $! || return 2
         cancel_lru_locks mdc
 
-       time2=`stat -c "%X" $DIR2/f23`
-
-       if (( $time2 <= $time1 )); then
-               error "atime doesn't update among nodes"
-       fi
+       time2=$(stat -c "%X" $DIR/$tfile)
+       echo "new atime is $time2"
 
-       rm -f $DIR1/f23 || error "rm -f $DIR1/f23 failed"
+       [ $time2 -gt $time1 ] || error "atime was not updated"
+       rm -f $DIR1/$tfile || error "rm -f $DIR1/$tfile failed"
        true
 }
 run_test 23 " others should see updated atime while another read===="
@@ -447,7 +523,7 @@ test_24a() {
        lfs df -i $DIR2 || error "lfs df -i $DIR2 failed"
        lfs df $DIR1/$tfile || error "lfs df $DIR1/$tfile failed"
        lfs df -ih $DIR2/$tfile || error "lfs df -ih $DIR2/$tfile failed"
-       
+
        OSC=`lctl dl | awk '/-osc-|OSC.*MNT/ {print $4}' | head -n 1`
 #      OSC=`lctl dl | awk '/-osc-/ {print $4}' | head -n 1`
        lctl --device %$OSC deactivate
@@ -459,14 +535,15 @@ run_test 24a "lfs df [-ih] [path] test ========================="
 
 test_24b() {
        touch $DIR1/$tfile
-       fsnum=`lfs df | grep -c "filesystem summary:"`
+       fsnum=$(lfs_df | grep -c "summary")
        [ $fsnum -eq 2 ] || error "lfs df shows $fsnum != 2 filesystems."
 }
 run_test 24b "lfs df should show both filesystems ==============="
 
-test_25() {
-       [ `lctl get_param -n mdc.*-mdc-*.connect_flags | grep -c acl` -lt 2 ] &&
-               skip "must have acl, skipping" && return
+test_25a() {
+       local acl=$(lctl get_param -n mdc.*MDT0000-mdc-*.connect_flags |
+                                                               grep -c acl)
+       [ "$acl" -lt 1 ] && skip "must have acl, skipping" && return
 
        mkdir -p $DIR1/$tdir
        touch $DIR1/$tdir/f1 || error "touch $DIR1/$tdir/f1"
@@ -488,7 +565,37 @@ test_25() {
 
        rm -rf $DIR1/$tdir
 }
-run_test 25 "change ACL on one mountpoint be seen on another ==="
+run_test 25a "change ACL on one mountpoint be seen on another ==="
+
+test_25b() {
+       local acl=$(lctl get_param -n mdc.*MDT0000-mdc-*.connect_flags |
+                                                       grep -c acl)
+       [ "$acl" -lt 1 ] && skip "must have acl, skipping" && return
+
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       rm -rf $DIR1/$tdir
+       $LFS mkdir -i 1 $DIR1/$tdir
+       touch $DIR1/$tdir/f1 || error "touch $DIR1/$tdir/f1"
+       chmod 0755 $DIR1/$tdir/f1 || error "chmod 0755 $DIR1/$tdir/f1"
+
+       $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #1"
+       setfacl -m u:$RUNAS_ID:--- -m g:$RUNAS_GID:--- $DIR1/$tdir ||
+               error "setfacl $DIR2/$tdir #1"
+       $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #2"
+       setfacl -m u:$RUNAS_ID:r-x -m g:$RUNAS_GID:r-x $DIR1/$tdir ||
+               error "setfacl $DIR2/$tdir #2"
+       $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #3"
+       setfacl -m u:$RUNAS_ID:--- -m g:$RUNAS_GID:--- $DIR1/$tdir ||
+               error "setfacl $DIR2/$tdir #3"
+       $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #4"
+       setfacl -x u:$RUNAS_ID: -x g:$RUNAS_GID: $DIR1/$tdir ||
+               error "setfacl $DIR2/$tdir #4"
+       $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #5"
+
+       rm -rf $DIR1/$tdir
+}
+run_test 25b "change ACL under remote dir on one mountpoint be seen on another"
 
 test_26a() {
         utime $DIR1/f26a -s $DIR2/f26a || error
@@ -535,8 +642,8 @@ test_28() { # bug 9977
        ECHO_UUID="ECHO_osc1_UUID"
        tOST=`$LCTL dl | | awk '/-osc-|OSC.*MNT/ { print $4 }' | head -1`
 
-       lfs setstripe $DIR1/$tfile -s 1048576 -i 0 -c 2
-       tOBJID=`lfs getstripe $DIR1/$tfile |grep "^[[:space:]]\+1" |awk '{print $2}'`
+       $LFS setstripe $DIR1/$tfile -S 1048576 -i 0 -c 2
+       tOBJID=`$LFS getstripe $DIR1/$tfile | awk '$1 == 1 {print $2}'`
        dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2
 
        $LCTL <<-EOF
@@ -545,7 +652,7 @@ test_28() { # bug 9977
                setup $tOST
        EOF
 
-       tECHOID=`$LCTL dl | grep $ECHO_UUID | awk '{print $1}'`
+       tECHOID=`$LCTL dl | grep $ECHO_UUID | awk '{ print $1 }'`
        $LCTL --device $tECHOID destroy "${tOBJID}:0"
 
        $LCTL <<-EOF
@@ -580,34 +687,40 @@ test_29() { # bug 10999
 #bug 11549 - permanently turn test off in b1_5
 run_test 29 "lock put race between glimpse and enqueue ========="
 
-test_30() { #bug #11110
-    mkdir -p $DIR1/$tdir
-    cp -f /bin/bash $DIR1/$tdir/bash
-    /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash; cp /bin/bash $DIR2/$tdir' &
-    err=$($DIR1/$tdir/bash -c 'sleep 2; openfile -f O_RDONLY /proc/$$/exe >& /dev/null; echo $?')
-    wait
-    [ $err -ne 116 ] && error_ignore 12900 "return code ($err) != -ESTALE" && return
-    true
+test_30() { #bug #11110, LU-2523
+       test_mkdir -p $DIR1/$tdir
+       cp -f /bin/bash $DIR1/$tdir/bash
+       /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash;
+                   cp /bin/bash $DIR2/$tdir' &
+       $DIR1/$tdir/bash -c 'sleep 2;
+               openfile -f O_RDONLY /proc/$$/exe >& /dev/null; echo $?'
+       wait
+       true
 }
 
-run_test 30 "recreate file race ========="
+run_test 30 "recreate file race"
 
 test_31a() {
-        mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
-        writes=`LANG=C dd if=/dev/zero of=$DIR/$tdir/$tfile count=1 2>&1 |
-                awk 'BEGIN { FS="+" } /out/ {print $1}'`
-        #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
-        lctl set_param fail_loc=0x314
-        reads=`LANG=C dd if=$DIR2/$tdir/$tfile of=/dev/null 2>&1 |
-               awk 'BEGIN { FS="+" } /in/ {print $1}'`
-        [ $reads -eq $writes ] || error "read" $reads "blocks, must be" $writes
+       test_mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
+       local writes=$(LANG=C dd if=/dev/zero of=$DIR/$tdir/$tfile \
+                      count=1 2>&1 | awk 'BEGIN { FS="+" } /out/ {print $1}')
+       #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
+       lctl set_param fail_loc=0x314
+       local reads=$(LANG=C dd if=$DIR2/$tdir/$tfile of=/dev/null 2>&1 |
+                     awk 'BEGIN { FS="+" } /in/ {print $1}')
+       [ $reads -eq $writes ] || error "read" $reads "blocks, must be" $writes
 }
 run_test 31a "voluntary cancel / blocking ast race=============="
 
 test_31b() {
-        remote_ost || { skip "local OST" && return 0; }
-        remote_ost_nodsh && skip "remote OST w/o dsh" && return 0
-        mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
+       remote_ost || { skip "local OST" && return 0; }
+       remote_ost_nodsh && skip "remote OST w/o dsh" && return 0
+
+       # make sure there is no local locks due to destroy
+       wait_mds_ost_sync || error "wait_mds_ost_sync()"
+       wait_delete_completed || error "wait_delete_completed()"
+
+       test_mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
         lfs setstripe $DIR/$tdir/$tfile -i 0 -c 1
         cp /etc/hosts $DIR/$tdir/$tfile
         #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
@@ -629,8 +742,8 @@ enable_lockless_truncate() {
 }
 
 test_32a() { # bug 11270
-        local p="$TMP/sanityN-$TESTNAME.parameters"
-        save_lustre_params $HOSTNAME osc.*.lockless_truncate > $p
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_lustre_params client "osc.*.lockless_truncate" > $p
         cancel_lru_locks osc
         enable_lockless_truncate 1
         rm -f $DIR1/$tfile
@@ -668,15 +781,19 @@ run_test 32a "lockless truncate"
 test_32b() { # bug 11270
         remote_ost_nodsh && skip "remote OST with nodsh" && return
 
-        local node
-        local p="$TMP/sanityN-$TESTNAME.parameters"
-        save_lustre_params $HOSTNAME "osc.*.contention_seconds" > $p
-        for node in $(osts_nodes); do
-                save_lustre_params $node "ldlm.namespaces.filter-*.max_nolock_bytes" >> $p
-                save_lustre_params $node "ldlm.namespaces.filter-*.contended_locks" >> $p
-                save_lustre_params $node "ldlm.namespaces.filter-*.contention_seconds" >> $p
-        done
-        clear_osc_stats
+       local node
+       local facets=$(get_facets OST)
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+
+       save_lustre_params client "osc.*.contention_seconds" > $p
+       save_lustre_params $facets \
+               "ldlm.namespaces.filter-*.max_nolock_bytes" >> $p
+       save_lustre_params $facets \
+               "ldlm.namespaces.filter-*.contended_locks" >> $p
+       save_lustre_params $facets \
+               "ldlm.namespaces.filter-*.contention_seconds" >> $p
+       clear_osc_stats
+
         # agressive lockless i/o settings
         for node in $(osts_nodes); do
                 do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 2000000; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 0; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 60'
@@ -716,11 +833,10 @@ print_jbd_stat () {
     local stat=0
     for mds in ${mdts//,/ }; do
         varsvc=${mds}_svc
-        dev=$(basename $(do_facet $mds lctl get_param -n osd*.${!varsvc}.mntdev))
-        val=$(do_facet $mds "procfile=/proc/fs/jbd/$dev/info;
-[ -f \\\$procfile ] || procfile=/proc/fs/jbd2/$dev/info;
-[ -f \\\$procfile ] || procfile=/proc/fs/jbd2/${dev}\:\\\*/info;
-cat \\\$procfile | head -1;")
+        dev=$(basename $(do_facet $mds "lctl get_param -n osd*.${!varsvc}.mntdev|\
+               xargs readlink -f" ))
+        val=$(do_facet $mds "cat /proc/fs/jbd*/${dev}{,:*,-*}/info 2>/dev/null|\
+               head -1")
         val=${val%% *};
         stat=$(( stat + val))
     done
@@ -731,18 +847,20 @@ cat \\\$procfile | head -1;")
 test_33a() {
     remote_mds_nodsh && skip "remote MDS with nodsh" && return
 
-    [ -n "$CLIENTS" ] || { skip "Need two or more clients" && return 0; }
-    [ $CLIENTCOUNT -ge 2 ] || \
-        { skip "Need two or more clients, have $CLIENTCOUNT" && return 0; }
+    [ -z "$CLIENTS" ] && skip "Need two or more clients, have $CLIENTS" && return 0
+    [ $CLIENTCOUNT -lt 2 ] &&
+       skip "Need two or more clients, have $CLIENTCOUNT" && return 0
 
     local nfiles=${TEST33_NFILES:-10000}
     local param_file=$TMP/$tfile-params
+    local fstype=$(facet_fstype $SINGLEMDS)
 
-    save_lustre_params $(comma_list $(mdts_nodes)) "mdt.*.commit_on_sharing" > $param_file
+       save_lustre_params $(get_facets MDS) \
+               "mdt.*.commit_on_sharing" > $param_file
 
     local COS
-    local jbdold
-    local jbdnew
+    local jbdold="N/A"
+    local jbdnew="N/A"
     local jbd
 
     for COS in 0 1; do
@@ -752,13 +870,13 @@ test_33a() {
         for i in 1 2 3; do
             do_nodes $CLIENT1,$CLIENT2 "mkdir -p $DIR1/$tdir-\\\$(hostname)-$i"
 
-            jbdold=$(print_jbd_stat)
+            [ $fstype = ldiskfs ] && jbdold=$(print_jbd_stat)
             echo "=== START createmany old: $jbdold transaction"
             local elapsed=$(do_and_time "do_nodes $CLIENT1,$CLIENT2 createmany -o $DIR1/$tdir-\\\$(hostname)-$i/f- -r $DIR2/$tdir-\\\$(hostname)-$i/f- $nfiles > /dev/null 2>&1")
-            jbdnew=$(print_jbd_stat)
-            jbd=$(( jbdnew - jbdold ))
+            [ $fstype = ldiskfs ] && jbdnew=$(print_jbd_stat)
+            [ $fstype = ldiskfs ] && jbd=$(( jbdnew - jbdold ))
             echo "=== END   createmany new: $jbdnew transaction :  $jbd transactions  nfiles $nfiles time $elapsed COS=$COS"
-            avgjbd=$(( avgjbd + jbd ))
+            [ $fstype = ldiskfs ] && avgjbd=$(( avgjbd + jbd ))
             avgtime=$(( avgtime + elapsed ))
         done
         eval cos${COS}_jbd=$((avgjbd / 3))
@@ -776,6 +894,66 @@ test_33a() {
 }
 run_test 33a "commit on sharing, cross crete/delete, 2 clients, benchmark"
 
+# commit on sharing tests
+test_33b() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+
+       [ -n "$CLIENTS" ] || { skip "Need two or more clients" && return 0; }
+       [ $CLIENTCOUNT -ge 2 ] ||
+               { skip "Need two or more clients, have $CLIENTCOUNT" &&
+                                                               return 0; }
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       local nfiles=${TEST33_NFILES:-10000}
+       local param_file=$TMP/$tfile-params
+
+       save_lustre_params $(get_facets MDS) \
+               "mdt.*.commit_on_sharing" > $param_file
+
+       local COS
+       local jbdold
+       local jbdnew
+       local jbd
+       local MDTIDX=1
+
+       for COS in 0 1; do
+               do_facet $SINGLEMDS lctl set_param mdt.*.commit_on_sharing=$COS
+               avgjbd=0
+               avgtime=0
+               for i in 1 2 3; do
+                       do_node $CLIENT1 "$LFS mkdir -i $MDTIDX -p \
+                                         $DIR1/$tdir-\\\$(hostname)-$i"
+
+                       jbdold=$(print_jbd_stat)
+                       echo "=== START createmany old: $jbdold transaction"
+                       local elapsed=$(do_and_time "do_nodes $CLIENT1,$CLIENT2\
+                               createmany -o $DIR1/$tdir-\\\$(hostname)-$i/f- \
+                               -r $DIR2/$tdir-\\\$(hostname)-$i/f- $nfiles > \
+                                                               /dev/null 2>&1")
+                       jbdnew=$(print_jbd_stat)
+                       jbd=$(( jbdnew - jbdold ))
+                       echo "=== END   createmany new: $jbdnew transaction : \
+                       $jbd transactions nfiles $nfiles time $elapsed COS=$COS"
+                       avgjbd=$(( avgjbd + jbd ))
+                       avgtime=$(( avgtime + elapsed ))
+               done
+               eval cos${COS}_jbd=$((avgjbd / 3))
+               eval cos${COS}_time=$((avgtime / 3))
+       done
+
+       echo "COS=0 transactions (avg): $cos0_jbd  time (avg): $cos0_time"
+       echo "COS=1 transactions (avg): $cos1_jbd  time (avg): $cos1_time"
+       [ "$cos0_jbd" != 0 ] &&
+           echo "COS=1 vs COS=0 jbd: $(((cos1_jbd/cos0_jbd - 1) * 100)) %"
+       [ "$cos0_time" != 0 ] &&
+           echo "COS=1 vs COS=0 time: $(((cos1_time/cos0_time - 1) * 100)) %"
+
+       restore_lustre_params < $param_file
+       rm -f $param_file
+       return 0
+}
+run_test 33b "COS: cross create/delete, 2 clients, benchmark under remote dir"
+
 # End commit on sharing tests
 
 get_ost_lock_timeouts() {
@@ -787,10 +965,21 @@ get_ost_lock_timeouts() {
     echo $locks
 }
 
+cleanup_34() {
+       local i
+       trap 0
+       do_nodes $(comma_list $(osts_nodes)) \
+               "lctl set_param -n fail_loc=0 2>/dev/null || true"
+       for i in $(seq $OSTCOUNT); do
+               wait_osc_import_state client ost$i FULL
+       done
+}
+
 test_34() { #16129
         local OPER
         local lock_in
         local lock_out
+       trap cleanup_34 EXIT RETURN
         for OPER in notimeout timeout ; do
                 rm $DIR1/$tfile 2>/dev/null
                 lock_in=$(get_ost_lock_timeouts)
@@ -829,6 +1018,7 @@ test_34() { #16129
                         fi
                 fi
         done
+       cleanup_34
 }
 run_test 34 "no lock timeout under IO"
 
@@ -841,7 +1031,7 @@ test_35() { # bug 17645
             let count=count+1
         done
 
-        mkdir -p $MOUNT1/$tfile
+       test_mkdir -p $MOUNT1/$tfile
         cancel_lru_locks mdc
 
         # Let's initiate -EINTR situation by setting fail_loc and take
@@ -889,43 +1079,45 @@ test_35() { # bug 17645
 run_test 35 "-EINTR cp_ast vs. bl_ast race does not evict client"
 
 test_36() { #bug 16417
-    local SIZE
-    local SIZE_B
-    local i
-
-    mkdir -p $DIR1/$tdir
-    $LFS setstripe -c -1 $DIR1/$tdir
-    i=0
-    SIZE=50
-    let SIZE_B=SIZE*1024*1024
-
-    while [ $i -le 10 ]; do
-        lctl mark "start test"
-        local before=$($LFS df | awk '{if ($1 ~/^filesystem/) {print $5; exit} }')
-        dd if=/dev/zero of=$DIR1/$tdir/file000 bs=1M count=$SIZE
-        sync
-        sleep 1
-        local after_dd=$($LFS df | awk '{if ($1 ~/^filesystem/) {print $5; exit} }')
-        multiop_bg_pause $DIR2/$tdir/file000 O_r${SIZE_B}c || return 3
-        read_pid=$!
-        rm -f $DIR1/$tdir/file000
-        kill -USR1 $read_pid
-        wait $read_pid
-        sleep 1
-        local after=$($LFS df | awk '{if ($1 ~/^filesystem/) {print $5; exit} }')
-        echo "*** cycle($i) *** before($before):after_dd($after_dd):after($after)"
-        # this free space! not used
-        if [ $after_dd -ge $after ]; then
-            error "space leaked"
-            return 1;
-        fi
-        let i=i+1
-            done
+       local SIZE
+       local SIZE_B
+       local i
+
+       test_mkdir -p $DIR1/$tdir
+       $LFS setstripe -c -1 $DIR1/$tdir
+       i=0
+       SIZE=50
+       let SIZE_B=SIZE*1024*1024
+       sync; sleep 5; sync # wait for delete thread
+
+       while [ $i -le 10 ]; do
+               lctl mark "start test"
+               local before=$(lfs_df $MOUNT1 | awk '/^filesystem/{ print $4; exit }')
+               dd if=/dev/zero of=$DIR1/$tdir/$tfile bs=1M count=$SIZE ||
+                       error "dd $DIR1/$tdir/$tfile ${SIZE}MB failed"
+               sync          # sync data from client cache
+               sync_all_data # sync data from server cache (delayed allocation)
+               sleep 2
+               local after_dd=$(lfs_df $MOUNT1 | awk '/^filesystem/{ print $4; exit }')
+               multiop_bg_pause $DIR2/$tdir/$tfile O_r${SIZE_B}c || return 3
+               read_pid=$!
+               rm -f $DIR1/$tdir/$tfile
+               kill -USR1 $read_pid
+               wait $read_pid
+               wait_delete_completed
+               local after=$(lfs_df $MOUNT1 | awk '/^filesystem/{ print $4; exit }')
+               echo "*** cycle($i) *** before($before) after_dd($after_dd)" \
+                       "after($after)"
+               # this free space! not used
+               (( $after_dd <= $after)) ||
+                       error "space leaked after_dd:$after_dd > after:$after"
+               let i=i+1
+       done
 }
-run_test 36 "handle ESTALE/open-unlink corectly"
+run_test 36 "handle ESTALE/open-unlink correctly"
 
 test_37() { # bug 18695
-       mkdir -p $DIR1/$tdir
+       test_mkdir -p $DIR1/$tdir
        multiop_bg_pause $DIR1/$tdir D_c || return 1
        MULTIPID=$!
        # create large directory (32kB seems enough from e2fsck, ~= 1000 files)
@@ -1068,6 +1260,12 @@ test_40a() {
        rm $DIR2/$tfile-4 $DIR2/$tfile-5
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
+
+       if [ $MDSCOUNT -ge 2 ]; then
+               $LFS mkdir -i 1 $DIR2/$tfile-6
+               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
+       fi
+
        # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
@@ -1097,7 +1295,13 @@ test_40b() {
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
        # all operations above shouldn't wait the first one
-       check_pdo_conflict $PID1 || error "parallel operation is blocked"
+
+       if [ $MDSCOUNT -ge 2 ]; then
+               $LFS mkdir -i 1 $DIR2/$tfile-6
+               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
+       fi
+
+        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
        rm -r $DIR1/*
        return 0
@@ -1125,7 +1329,13 @@ test_40c() {
        rm $DIR2/$tfile-4 $DIR2/$tfile-5
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
-       # all operations above shouldn't wait the first one
+
+       if [ $MDSCOUNT -ge 2 ]; then
+               $LFS mkdir -i 1 $DIR2/$tfile-6
+               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
+       fi
+
+        # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
        rm -r $DIR1/*
@@ -1154,6 +1364,12 @@ test_40d() {
        rm $DIR2/$tfile-4 $DIR2/$tfile-5
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
+
+       if [ $MDSCOUNT -ge 2 ]; then
+               $LFS mkdir -i 1 $DIR2/$tfile-6
+               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
+       fi
+
        # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
@@ -1180,7 +1396,13 @@ test_40e() {
        rm $DIR2/$tfile-4 $DIR2/$tfile-2
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
-       # all operations above shouldn't wait the first one
+
+       if [ $MDSCOUNT -ge 2 ]; then
+               $LFS mkdir -i 1 $DIR2/$tfile-6
+               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
+       fi
+
+       # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
        rm -r $DIR1/*
@@ -1192,7 +1414,7 @@ run_test 40e "pdirops: rename and others =============="
 test_41a() {
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
        mkdir $DIR2/$tfile && error "mkdir must fail"
@@ -1205,10 +1427,10 @@ run_test 41a "pdirops: create vs mkdir =============="
 test_41b() {
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
-       multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
+       $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
        rm -r $DIR1/*
        return 0
@@ -1219,7 +1441,7 @@ test_41c() {
        touch $DIR1/$tfile-2
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
        link $DIR2/$tfile-2 $DIR2/$tfile && error "link must fail"
@@ -1232,7 +1454,7 @@ run_test 41c "pdirops: create vs link =============="
 test_41d() {
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
        rm $DIR2/$tfile || error "unlink must succeed"
@@ -1246,7 +1468,7 @@ test_41e() {
        touch $DIR1/$tfile-2
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
        mv $DIR2/$tfile-2 $DIR2/$tfile || error "rename must succeed"
@@ -1259,7 +1481,7 @@ run_test 41e "pdirops: create and rename (tgt) =============="
 test_41f() {
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
        mv $DIR2/$tfile $DIR2/$tfile-2 || error "rename must succeed"
@@ -1272,7 +1494,7 @@ run_test 41f "pdirops: create and rename (src) =============="
 test_41g() {
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
        stat $DIR2/$tfile > /dev/null || error "stat must succeed"
@@ -1285,7 +1507,7 @@ run_test 41g "pdirops: create vs getattr =============="
 test_41h() {
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
-       multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
+       $MULTIOP $DIR1/$tfile oO_CREAT:O_RDWR:c &
        PID1=$!
        sleep 1
        ls -lia $DIR2/ > /dev/null
@@ -1315,7 +1537,7 @@ test_42b() {
        mkdir $DIR1/$tfile &
        PID1=$!
        sleep 1
-       multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
+       $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
        rm -r $DIR1/*
        return 0
@@ -1424,7 +1646,7 @@ test_43b() {
        rm $DIR1/$tfile &
        PID1=$!
        sleep 1
-       multiop $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
+       $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
        rm -r $DIR1/*
        return 0
@@ -1517,6 +1739,22 @@ test_43h() {
 }
 run_test 43h "pdirops: unlink vs readdir =============="
 
+test_43i() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       touch $DIR1/$tfile
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       rm $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       $LFS mkdir -i 1 $DIR2/$tfile || error "remote mkdir must succeed"
+       check_pdo_conflict $PID1 &&
+               { wait $PID1; error "remote mkdir isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 43i "pdirops: unlink vs remote mkdir"
+
 # test 44: rename tgt and blocking operations
 test_44a() {
        touch $DIR1/$tfile-2
@@ -1539,7 +1777,7 @@ test_44b() {
        mv $DIR1/$tfile-2 $DIR1/$tfile &
        PID1=$!
        sleep 1
-       multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
+       $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
        rm -r $DIR1/*
        return 0
@@ -1634,6 +1872,23 @@ test_44h() {
 }
 run_test 44h "pdirops: rename tgt vs readdir =============="
 
+# test 44: rename tgt and blocking operations
+test_44i() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       touch $DIR1/$tfile-2
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2   0x146
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
+       mv $DIR1/$tfile-2 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       $LFS mkdir -i 1 $DIR2/$tfile && error "remote mkdir must fail"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                               error "remote mkdir isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 44i "pdirops: rename tgt vs remote mkdir"
+
 # test 45: rename src and blocking operations
 test_45a() {
        touch $DIR1/$tfile
@@ -1656,7 +1911,7 @@ test_45b() {
        mv $DIR1/$tfile $DIR1/$tfile-2 &
        PID1=$!
        sleep 1
-       multiop $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
+       $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
        rm -r $DIR1/*
        return 0
@@ -1728,7 +1983,7 @@ test_45g() {
        mv $DIR1/$tfile $DIR1/$tfile-2 &
        PID1=$!
        sleep 1
-       stat $DIR2/$tfile > /dev/null && "stat must fail"
+       stat $DIR2/$tfile > /dev/null && error "stat must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
        rm -r $DIR1/*
        return 0
@@ -1749,6 +2004,22 @@ test_45h() {
 }
 run_test 45h "pdirops: unlink vs readdir =============="
 
+test_45i() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       touch $DIR1/$tfile
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       mv $DIR1/$tfile $DIR1/$tfile-2 &
+       PID1=$!
+       sleep 1
+       $LFS mkdir -i 1 $DIR2/$tfile || error "create remote dir must succeed"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                               error "create remote dir isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 45i "pdirops: rename src vs remote mkdir"
+
 # test 46: link and blocking operations
 test_46a() {
        touch $DIR1/$tfile-2
@@ -1771,7 +2042,7 @@ test_46b() {
        link $DIR1/$tfile-2 $DIR1/$tfile &
        PID1=$!
        sleep 1
-       multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
+       $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
        rm -r $DIR1/*
        return 0
@@ -1858,12 +2129,135 @@ test_46h() {
        PID1=$!
        sleep 1
        ls -lia $DIR2/ > /dev/null
-       check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
+       check_pdo_conflict $PID1 && { wait $PID1;
+                       error "readdir isn't blocked"; }
        rm -r $DIR1/*
        return 0
 }
 run_test 46h "pdirops: link vs readdir =============="
 
+test_46i() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       touch $DIR1/$tfile-2
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       link $DIR1/$tfile-2 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       $LFS mkdir -i 1 $DIR2/$tfile && error "remote mkdir must fail"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                               error "remote mkdir isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 46i "pdirops: link vs remote mkdir"
+
+# test 47: remote mkdir and blocking operations
+test_47a() {
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       $LFS mkdir -i 1 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       mkdir $DIR2/$tfile && error "mkdir must fail"
+       check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 47a "pdirops: remote mkdir vs mkdir"
+
+test_47b() {
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       $LFS mkdir -i 1 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                                       error "create isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 47b "pdirops: remote mkdir vs create"
+
+test_47c() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       touch $DIR1/$tfile-2
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       $LFS mkdir -i 1 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       link $DIR2/$tfile-2 $DIR2/$tfile && error "link must fail"
+       check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 47c "pdirops: remote mkdir vs link"
+
+test_47d() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       $LFS mkdir -i 1 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       rmdir $DIR2/$tfile || error "unlink must succeed"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                                       error "unlink isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 47d "pdirops: remote mkdir vs unlink"
+
+test_47e() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       touch $DIR1/$tfile-2
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       $LFS mkdir -i 1 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       mv -T $DIR2/$tfile-2 $DIR2/$tfile && error "rename must fail"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                                       error "rename isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 47e "pdirops: remote mkdir and rename (tgt)"
+
+test_47f() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       $LFS mkdir -i 1 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       mv $DIR2/$tfile $DIR2/$tfile-2 || error "rename must succeed"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                                       error "rename isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 47f "pdirops: remote mkdir and rename (src)"
+
+test_47g() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+#define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       $LFS mkdir -i 1 $DIR1/$tfile &
+       PID1=$!
+       sleep 1
+       stat $DIR2/$tfile > /dev/null || error "stat must succeed"
+       check_pdo_conflict $PID1 && { wait $PID1;
+                                       error "getattr isn't blocked"; }
+       rm -r $DIR1/*
+       return 0
+}
+run_test 47g "pdirops: remote mkdir vs getattr"
+
 test_50() {
         trunc_size=4096
         dd if=/dev/zero of=$DIR1/$tfile bs=1K count=10
@@ -1877,10 +2271,282 @@ test_50() {
 }
 run_test 50 "osc lvb attrs: enqueue vs. CP AST =============="
 
+test_51a() {
+       local filesize
+       local origfile=/etc/hosts
+
+       filesize=`stat -c %s $origfile`
+
+       # create an empty file
+       $MCREATE $DIR1/$tfile
+       # cache layout lock on both mount point
+       stat $DIR1/$tfile > /dev/null
+       stat $DIR2/$tfile > /dev/null
+
+       # open and sleep 2 seconds then read
+       $MULTIOP $DIR2/$tfile o_2r${filesize}c &
+       local pid=$!
+       sleep 1
+
+       # create the layout of testing file
+       dd if=$origfile of=$DIR1/$tfile conv=notrunc > /dev/null
+
+       # MULTIOP proc should be able to read enough bytes and exit
+       sleep 2
+       kill -0 $pid && error "multiop is still there"
+       cmp $origfile $DIR2/$tfile || error "$MCREATE and $DIR2/$tfile differs"
+
+       rm -f $DIR1/$tfile
+}
+run_test 51a "layout lock: refresh layout should work"
+
+test_51b() {
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.59) ]] ||
+               { skip "Need MDS version at least 2.3.59"; return 0; }
+
+       local tmpfile=`mktemp`
+
+       # create an empty file
+       $MCREATE $DIR1/$tfile
+
+       # delay glimpse so that layout has changed when glimpse finish
+#define OBD_FAIL_GLIMPSE_DELAY 0x1404
+       $LCTL set_param fail_loc=0x1404
+       stat -c %s $DIR2/$tfile |tee $tmpfile &
+       local pid=$!
+       sleep 1
+
+       # create layout of testing file
+       dd if=/dev/zero of=$DIR1/$tfile bs=1k count=1 conv=notrunc > /dev/null
+
+       wait $pid
+       local fsize=`cat $tmpfile`
+
+       [ x$fsize = x1024 ] || error "file size is $fsize, should be 1024"
+
+       rm -f $DIR1/$tfile $tmpfile
+}
+run_test 51b "layout lock: glimpse should be able to restart if layout changed"
+
+test_51c() {
+       # create an empty file
+       $MCREATE $DIR1/$tfile
+
+#define OBD_FAIL_MDS_LL_BLOCK 0x172
+       $LCTL set_param fail_loc=0x172
+
+       # change the layout of testing file
+       echo "Setting layout ..."
+       $LFS setstripe -c $OSTCOUNT $DIR1/$tfile &
+       pid=$!
+       sleep 1
+
+       # get layout of this file should wait until dd is finished
+       local stripecnt=`$LFS getstripe -c $DIR2/$tfile`
+       [ $stripecnt -eq $OSTCOUNT ] || error "layout wrong"
+
+       rm -f $DIR1/$tfile
+}
+run_test 51c "layout lock: IT_LAYOUT blocked and correct layout can be returned"
+
+test_60() {
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.0) ]] ||
+       { skip "Need MDS version at least 2.3.0"; return; }
+       # Create a file
+       test_mkdir -p $DIR1/$tdir
+       file1=$DIR1/$tdir/file
+       file2=$DIR2/$tdir/file
+
+       echo orig > $file2 || error "Could not create $file2"
+       version=$($LFS data_version $file1)
+
+       # Append data
+       echo append >> $file2 || error "Could not append to $file2"
+       version2=$($LFS data_version $file1)
+       [ "$version" != "$version2" ] ||
+           error "append did not change data version: $version"
+
+       # Overwrite data
+       echo overwrite > $file2 || error "Could not overwrite $file2"
+       version3=$($LFS data_version $file1)
+       [ "$version2" != "$version3" ] ||
+           error "overwrite did not change data version: $version2"
+
+       # Truncate before EOF
+       $TRUNCATE $file2 3 || error "Could not truncate $file2"
+       version4=$($LFS data_version $file1)
+       [ "$version3" != "$version4" ] ||
+           error "truncate did not change data version: $version3"
+
+       # Truncate after EOF
+       $TRUNCATE $file2 123456 || error "Could not truncate $file2"
+       version5=$($LFS data_version $file1)
+       [ "$version4" != "$version5" ] ||
+           error "truncate did not change data version: $version4"
+
+       # Chmod do not change version
+       chmod 400 $file2 || error "Could not chmod 400 $file2"
+       version6=$($LFS data_version $file1)
+       [ "$version5" == "$version6" ] ||
+           error "chmod should not change data version: $version5 != $version6"
+
+       # Chown do not change version
+       chown $RUNAS_ID $file2 || error "Could not chown $RUNAS_ID $file2"
+       version7=$($LFS data_version $file1)
+       [ "$version5" == "$version7" ] ||
+           error "chown should not change data version: $version5 != $version7"
+}
+run_test 60 "Verify data_version behaviour"
+
+test_70a() {
+       local test_dir=$tdir/test_dir
+
+       mkdir -p $DIR1/$tdir
+       if [ $MDSCOUNT -ge 2 ]; then
+               local MDTIDX=1
+               $LFS mkdir -i $MDTIDX $DIR1/$test_dir ||
+                       error "Create remote directory failed"
+       else
+               mkdir -p $DIR1/$test_dir
+       fi
+       cd $DIR2/$test_dir || error "cd directory failed"
+       rm -rf $DIR1/$test_dir || error "unlink directory failed"
+
+       cd $DIR2/$tdir || error "exit directory"
+}
+run_test 70a "cd directory && rm directory"
+
+test_70b() { # LU-2781
+       local i
+       mkdir -p $DIR1/$tdir
+
+       touch $DIR1/$tdir/file
+       for ((i = 0; i < 32; i++)); do
+           $LFS rm_entry $DIR1/$tdir/non_existent_dir &>/dev/null
+       done
+       rm $DIR1/$tdir/file || error "cannot remove file after rm_entry"
+
+       touch $DIR1/$tdir/file
+       $LFS mkdir -i0 $DIR1/$tdir/test_dir
+       $LFS rm_entry $DIR1/$tdir/test_dir &>/dev/null
+       rm -rf $DIR1/$tdir/test_dir ||
+               error "cannot remove directory after rm_entry"
+       rm $DIR1/$tdir/file || error "cannot remove file after rm_entry"
+}
+run_test 70b "remove files after calling rm_entry"
+
+test_71() {
+       local server_version=$(lustre_version_code $SINGLEMDS)
+
+       [[ $server_version -lt $(version_code 2.1.6) ]] &&
+               skip "Need MDS version at least 2.1.6" && return
+
+       # Patch not applied to 2.2 and 2.3 branches
+       [[ $server_version -ge $(version_code 2.2.0) ]] &&
+       [[ $server_version -lt $(version_code 2.4.0) ]] &&
+               skip "Need MDS version at least 2.4.0" && return
+
+       checkfiemap --test ||
+               { skip "checkfiemap not runnable: $?" && return; }
+       # write data this way: hole - data - hole - data
+       dd if=/dev/urandom of=$DIR1/$tfile bs=40K seek=1 count=1
+       [ "$(facet_fstype ost$(($($GETSTRIPE -i $DIR1/$tfile) + 1)))" = \
+               "zfs" ] &&
+               skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return 0
+       dd if=/dev/urandom of=$DIR1/$tfile bs=40K seek=3 count=1
+       GET_STAT="lctl get_param -n ldlm.services.ldlm_cbd.stats"
+       stat $DIR2/$tfile
+       local can1=$($GET_STAT | awk '/ldlm_bl_callback/ {print $2}')
+       echo $can1
+       checkfiemap $DIR2/$tfile 81920 ||
+               error "data is not flushed from client"
+       local can2=$($GET_STAT | awk '/ldlm_bl_callback/ {print $2}')
+       echo $can2
+
+       # common case of "create file, copy file" on a single node
+       # should not flush data from ost
+       dd if=/dev/urandom of=$DIR1/$tfile bs=40K seek=1 count=1
+       dd if=/dev/urandom of=$DIR1/$tfile bs=40K seek=3 count=1
+       stat $DIR1/$tfile
+       local can3=$($GET_STAT | awk '/ldlm_bl_callback/ {print $2}')
+       echo $can3
+       checkfiemap $DIR1/$tfile 81920 ||
+       error 4
+       local can4=$($GET_STAT | awk '/ldlm_bl_callback/ {print $2}')
+       echo $can2
+       [ $can3 -eq $can4 ] || error $((can2-can1)) "cancel RPC occured."
+}
+run_test 71 "correct file map just after write operation is finished"
+
+test_72() {
+       local p="$TMP/sanityN-$TESTNAME.parameters"
+       local tlink1
+       local tlink2
+       save_lustre_params client "llite.*.xattr_cache" > $p
+       lctl set_param llite.*.xattr_cache 1 ||
+               { skip "xattr cache is not supported"; return 0; }
+
+       touch $DIR1/$tfile
+       setfattr -n user.attr1 -v value1 $DIR1/$tfile ||
+               error "setfattr1 failed"
+       getfattr -n user.attr1 $DIR2/$tfile | grep value1 ||
+               error "getfattr1 failed"
+       setfattr -n user.attr1 -v value2 $DIR2/$tfile ||
+               error "setfattr2 failed"
+       getfattr -n user.attr1 $DIR1/$tfile | grep value2 ||
+               error "getfattr2 failed"
+
+       # check that trusted.link is consistent
+       tlink1=$(getfattr -n trusted.link $DIR1/$tfile | md5sum)
+       ln $DIR2/$tfile $DIR2/$tfile-2 || error "failed to link"
+       tlink2=$(getfattr -n trusted.link $DIR1/$tfile | md5sum)
+       echo "$tlink1 $tlink2"
+       [ "$tlink1" = "$tlink2" ] && error "trusted.link should have changed!"
+
+       rm -f $DIR2/$tfile
+
+       restore_lustre_params < $p
+       rm -f $p
+}
+run_test 72 "getxattr/setxattr cache should be consistent between nodes"
+
+test_73() {
+       local p="$TMP/sanityN-$TESTNAME.parameters"
+       save_lustre_params client "llite.*.xattr_cache" > $p
+       lctl set_param llite.*.xattr_cache 1 ||
+               { skip "xattr cache is not supported"; return 0; }
+
+       touch $DIR1/$tfile
+       setfattr -n user.attr1 -v value1 $DIR1/$tfile ||
+               error "setfattr1 failed"
+       getfattr -n user.attr1 $DIR2/$tfile || error "getfattr1 failed"
+       getfattr -n user.attr1 $DIR1/$tfile || error "getfattr2 failed"
+       clear_llite_stats
+       # PR lock should be cached by now on both clients
+       getfattr -n user.attr1 $DIR1/$tfile || error "getfattr3 failed"
+       # 2 hits for getfattr(0)+getfattr(size)
+       [ $(calc_llite_stats getxattr_hits) -eq 2 ] || error "not cached in $DIR1"
+       getfattr -n user.attr1 $DIR2/$tfile || error "getfattr4 failed"
+       # 4 hits for more getfattr(0)+getfattr(size)
+       [ $(calc_llite_stats getxattr_hits) -eq 4 ] || error "not cached in $DIR2"
+       rm -f $DIR2/$tfile
+
+       restore_lustre_params < $p
+       rm -f $p
+}
+run_test 73 "getxattr should not cause xattr lock cancellation"
+
+test_74() {
+       dd if=/dev/zero of=$DIR1/$tfile-1 bs=1K count=1
+       dd if=/dev/zero of=$DIR1/$tfile-2 bs=1K count=1
+       flocks_test 4 $DIR1/$tfile-1 $DIR2/$tfile-2
+}
+run_test 74 "flock deadlock: different mounts =============="
+
 log "cleanup: ======================================================"
 
 [ "$(mount | grep $MOUNT2)" ] && umount $MOUNT2
 
-complete $(basename $0) $SECONDS
+complete $SECONDS
 check_and_cleanup_lustre
 exit_status